/*
3D Mesh Editer via "A Simple Approach to Interactive Free-Form 
Shape Deformations" 
Copyright:(c) Shin Yoshizawa, 2002
E-mail: shin.yoshizawa@mpi-sb.mpg.de
URL: http://www.mpi-sb.mpg.de/~shin
Affiliation: Max-Planck-Institut fuer Informatik: Computer Graphics Group 
 Stuhlsatzenhausweg 85, 66123 Saarbruecken, Germany
 Phone +49 681 9325-414 Fax +49 681 9325-499 

 All right is reserved by Shin Yoshizawa.
This java program and sources are allowed for only primary user of 
research and educational purposes. Don't use secondary: copy, distribution, 
diversion, business purpose, and etc.. 


 */

import java.io.*;
import java.applet.Applet;
import java.awt.FlowLayout;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.Hashtable;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.loaders.Scene;
import com.sun.j3d.loaders.objectfile.ObjectFile;
import com.sun.j3d.loaders.ParsingErrorException;
import com.sun.j3d.loaders.IncorrectFormatException;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.behaviors.interpolators.*;
import com.sun.j3d.utils.behaviors.picking.*;
import com.sun.j3d.utils.geometry.*;
import javax.swing.SwingUtilities;


public class DeformationMesh extends Frame implements Runnable,ActionListener,AdjustmentListener,ItemListener,TextListener{
  Color blanchedalmond  = new Color((float)(1.000000),
				    (float)(0.921569),(float)(0.803922));
  Color teal = new Color((float)(0.000000),(float)(0.501961),
                         (float)(0.501961));
  Transform3D initialcamera;
  Transform3D Rotate90;
  Transform3D initialView;
  Thread thread;

  boolean animate=false;
 boolean pickspherebindstate=true;
  //int interval = 20;
  int interval = 20;

  /* Camera Info. */
  Point3d eye = new Point3d(0.0,0.0,0.0);
  Point3d center = new Point3d(0.0,0.0,0.0);
  Vector3d up = new Vector3d(0.0,0.0,0.0);
 

  SimpleUniverse universe;
  Canvas3D           canvas;
 
  Polyhedron mypolygon=null;
  
  ControlInterface mycontrol=null;
  ObjectTransformEMesh myot;
  LineTransform lineot;
  LineTransform lineot2;
  
  MouseRotate rotBehavior;    
  MouseZoom zoomBehavior;
  MouseTranslate transBehavior;
  TransformGroup viewpoint=null;
  
  
  
  /* global variable */
  
  int numenettimes = 1;
  /* for application file I/O */
  Menu file;
  Menu save;
  Menu load;
  MenuItem loadp,savep,savei,loadc;
  MenuItem quit;
  MenuBar mfield;  
  Menu thspeed;
  CheckboxGroup cpstateG;
  Checkbox cps1,cps2,cps3,cps4;
  ControlPoint pickedCP=null;
  CheckboxGroup pickstateG;
  Checkbox pick1,pick2,pick3;
  Button pickclear;

  Checkbox weightFS;
  
  CheckboxMenuItem mytargetp,myaniso,aniaonst;
  CheckboxMenuItem ths1,ths2,ths3,ths4,ths5;

  Menu DMeshMeshM;
  
  
  Menu MethodConditionM;
  Menu ViewO;
  /* Menu Items */
  

  CheckboxMenuItem DMeshnormalcolor,DMeshmeanCPastelcolor,
    DMeshwireframecolor,DMeshnonecolor,DMeshtrOnOff,DMeshexist;
  CheckboxMenuItem DMeshlighton,DMeshbackfaceon,DMeshmlighton;
  
  
  
  CheckboxMenuItem Cprop;
  MenuItem CameraInit,CameraTop,CameraBottom,CameraFront,CameraBack,CameraRight,CameraLeft;
  
  Button InitPosition,ApplyENet,Animation;
  TextField ENetTimes;
  
    
  
  CheckboxMenuItem blend;
  /* Pick component */
  
  Vector3d view;
  Point3d picked;
  Point3d mouse;
  Point3d Onpicked;
  int pickstate =0;
  boolean objectpickstate=false;
  float Sphereradius = 0.04f;
  Transform3D motion;
  
  int picktype;
  PickObjectTransform picksphere=null;
  PickObjectTransform basesphere=null;
  PickObjectTransform  basesphere2=null;

    // UI Components
  

  Panel              controlPanel;
  Panel              canvasPanel;
  
  
  
  
  
  Scrollbar          thrSlider;
  Scrollbar          thrSliderEpsilon;
  Scrollbar          thrSliderAlpha;
  Scrollbar          thrSliderBeta;
  Scrollbar          thrSliderGamma;
  Scrollbar pickSlider;
    
      
  // Scene Graph
  BranchGroup scene;
    
  // Key Frames & Interpolator
  
  LightObject mylight=null;
  
  
    // Flags
  boolean            animationOn = false; 
  GridBagLayout gridbagl;
  
  GridBagConstraints gridbagc;
  public DeformationMesh() {
   
    gridbagl = new GridBagLayout();
    gridbagc = new GridBagConstraints();
    mfield = makeIOMenuBar();
    this. setLayout(gridbagl);
    this.setMenuBar(mfield); 
    // Create the canvas and the UI
    canvasPanel = new Panel();
    controlPanel = new Panel();
    createCanvasPanel(canvasPanel);
    createControlPanel(controlPanel); 
    
    
    gridbagc.weightx = GridBagConstraints.CENTER;
    //gridbagc.gridwidth = GridBagConstraints.REMAINDER;
    //gridbagc.gridy = GridBagConstraints.RELATIVE;
    
    gridbagl.setConstraints(canvasPanel,gridbagc);
    this.add(canvasPanel);
    
    gridbagc.ipadx = 2;
    gridbagc.gridy = GridBagConstraints.RELATIVE;
   
     gridbagl.setConstraints(controlPanel,gridbagc);
    this.add(controlPanel);
    
    
      

      // Create the scene. 
      scene = createRoot();
      initialcamera = new Transform3D();
      Rotate90  = new Transform3D();
      Rotate90.rotX(-((12.0*Math.PI)/20.0));
      mylight = new LightObject(scene);
      
	
      // Add viewing platform  
      universe = new SimpleUniverse(canvas);
      ViewingPlatform vplt = universe.getViewingPlatform();
      viewpoint = vplt.getViewPlatformTransform();
      initialView = new Transform3D();
      
      vplt.setNominalViewingTransform();
      viewpoint.getTransform(initialView);
      //View view = universe.getViewer().getView();
      //view.setDepthBufferFreezeTransparent(false);
      universe.addBranchGraph(scene);
      
      
      this.setForeground(teal);
      this.setBackground(blanchedalmond);
      thread = new Thread(this);
  }
  public void startloop(){
    
    if(!animate){
      animate=true;
     
      thread = new Thread(this);
      thread.start();
      
    }else{
      animate=false;
      //   canvas.startRenderer();
      

      /* this is */
      thread.interrupt();
    }
        
  }
public void run()
    {
      while(true){
	try{
          Thread.sleep(interval);
        
	}catch(InterruptedException e){
          //System.out.println("InterruptedException run error!");
          //break; 
	  thread.currentThread().interrupt();
	  //System.exit(0);
        }
	 if (thread.interrupted())break;
        this.Update();
      }
    }
  public void Update(){
     if(mycontrol!=null){
       mypolygon.UpdateCoordinate();
     }
    //ColorCheckSet();
  }
  public void destroy()
    {
        System.out.println("destroy thread");
        thread.interrupt();
	  //thread.stop();
    }
  public BranchGroup createRoot(){
    BranchGroup objRoot = new BranchGroup();
    objRoot.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
    objRoot.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
    objRoot.setCapability(BranchGroup.ALLOW_DETACH);
   
    TransformGroup objTrans = new TransformGroup();
    objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
       
    BoundingSphere bounds =
      new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);
    /*
    MouseRotate behavior = new MouseRotate();
    
    behavior.setTransformGroup(objTrans);
    objTrans.addChild(behavior);
    behavior.setSchedulingBounds(bounds);
    
    MouseZoom behavior2 = new MouseZoom();
    behavior2.setTransformGroup(objTrans);
    objTrans.addChild(behavior2);
    behavior2.setSchedulingBounds(bounds);
    
    MouseTranslate behavior3 = new MouseTranslate();
    behavior3.setTransformGroup(objTrans);
    objTrans.addChild(behavior3);
    behavior3.setSchedulingBounds(bounds);
    */
    // Set up the background
    // Color3f bgColor = new Color3f(0.09f, 0.09f, 0.9f);
    Color3f bgColor    = new Color3f(1.0f, 1.0f, 1.0f);
    
    Background bgNode = new Background(bgColor);
    bgNode.setApplicationBounds(bounds);
    objRoot.addChild(bgNode);
    
    // Set up the ambient light
    Color3f ambientColor = new Color3f(0.2f, 0.2f, 0.2f);
    AmbientLight ambientLightNode = new AmbientLight(ambientColor);
    ambientLightNode.setInfluencingBounds(bounds);
    
    objRoot.addChild(ambientLightNode);
    
    // Set up the directional lights
    Color3f light1Color = new Color3f(0.65f, 0.65f, 0.65f);
    Vector3f light1Direction  = new Vector3f(4.0f, -7.0f, -12.0f);
       
    DirectionalLight light1 = new DirectionalLight(light1Color, light1Direction);
    light1.setInfluencingBounds(bounds);
    objRoot.addChild(light1);
    objRoot.compile();
    return objRoot;
  }
  
  public TextField makeTextF(String str,int dn){
    TextField tmp = new TextField(str,dn);
    tmp.setForeground(teal);
    tmp.setBackground(blanchedalmond);
    tmp.addTextListener(this);
    return tmp;
  }
  public Button makeButton(String str){
    Button tmp = new Button(str);
    tmp.setFont(new Font("TimesRoman", Font.BOLD, 12));
    tmp.addActionListener(this);
    tmp.setForeground(teal);
    tmp.setBackground(blanchedalmond);
    return tmp;
  }
  public MenuItem makeMenuItem(String str){
    MenuItem tmp = new MenuItem(str);
    tmp.setFont(new Font("TimesRoman", Font.BOLD, 12));
    tmp.addActionListener(this);
    return tmp;
  }
  
  public Checkbox makeCheckbox(String str,CheckboxGroup cg,boolean judgement){
    Checkbox tmp = new Checkbox(str,cg,judgement);
    tmp.setFont(new Font("TimesRoman", Font.PLAIN, 10));
    tmp.addItemListener(this);
    tmp.setForeground(teal);
    tmp.setBackground(blanchedalmond);
    return tmp;
  }
  
  public Checkbox makeCheckbox(String str,boolean judgement){
    Checkbox tmp = new Checkbox(str,judgement);
    tmp.setFont(new Font("TimesRoman", Font.PLAIN, 12));
    tmp.addItemListener(this);
    tmp.setForeground(teal);
    tmp.setBackground(blanchedalmond);
    return tmp;
  }
  public CheckboxMenuItem makeCheckboxMenuItem(String str,boolean judgement){
    CheckboxMenuItem tmp = new CheckboxMenuItem(str,judgement);
    tmp.setFont(new Font("TimesRoman", Font.BOLD, 12));
    tmp.addItemListener(this);
    return tmp;
  }
    private void createControlPanel(Panel p) {

      p.setLayout(new GridLayout(10,1));
     
      Panel mypanel1 = new Panel();
      /*
      Label TitleLabel = new Label("3D Def. Mesh Sim.");
      TitleLabel.setFont(new Font("TimesRoman", Font.BOLD,12));
      p.add(TitleLabel); */ /* 0 */
      
      

      Panel app1 = new Panel();
      
      cpstateG = new CheckboxGroup();
      cps1 = makeCheckbox("s",cpstateG,false);
      cps2 = makeCheckbox("v",cpstateG,true);
      cps3 = makeCheckbox("cs",cpstateG,false);
      cps4 = makeCheckbox("cv",cpstateG,false);
      app1.add(cps1);
      app1.add(cps2);
      app1.add(cps3);
      app1.add(cps4);
       p.add(app1); /* 0 */
      Panel app1_2 = new Panel();
      weightFS = makeCheckbox("w",true);
      pickstateG = new CheckboxGroup();
      pick1 = makeCheckbox("no",pickstateG,true);
      pick2 = makeCheckbox("add",pickstateG,false);
       
      pickclear = makeButton("i");
      app1_2.add(weightFS);
      app1_2.add(pick1);
      app1_2.add(pick2);
      app1_2.add(pickclear);
      
      p.add(app1_2); /* 1 */
                        
      
      Panel app2 = new Panel();
      
      ApplyENet  = makeButton("E-Net");
      ENetTimes  = makeTextF("1",3);
      InitPosition = makeButton("I");
      app2.add(ApplyENet);
      app2.add(ENetTimes);
      app2.add(InitPosition);
      p.add(app2); /* 2 */
      
      Panel mypane10 = new Panel();
      Animation = makeButton("Start Animation");
      mypane10.add(Animation);
      p.add(mypane10);   /* 3 */ 

      

      /* Scrollbar */
      Panel dpaDMesh = new Panel();
      dpaDMesh.setLayout(new GridLayout(2,1));
      Label thrlabel2 = new Label("ep");
      thrlabel2.setFont(new Font("TimesRoman", Font.ITALIC, 10));
      thrSliderEpsilon = new Scrollbar(Scrollbar.HORIZONTAL,15,20,1, 120);
      thrSliderEpsilon.setSize(100,50);
      thrSliderEpsilon.setUnitIncrement (1);
      thrSliderEpsilon.addAdjustmentListener(this);
      dpaDMesh.add(thrlabel2);
      dpaDMesh.add(thrSliderEpsilon);
      p.add(dpaDMesh); /* 4 */
      

       Panel dpaDMesh2 = new Panel();
      dpaDMesh2.setLayout(new GridLayout(2,1));
      Label thrlabel22 = new Label("Alpha");
      thrlabel22.setFont(new Font("TimesRoman", Font.ITALIC, 10));
      thrSliderAlpha = new Scrollbar(Scrollbar.HORIZONTAL,20,50,1, 250);
      thrSliderAlpha.setSize(100,50);
      thrSliderAlpha.setUnitIncrement (1);
      thrSliderAlpha.addAdjustmentListener(this);
      dpaDMesh2.add(thrlabel22);
      dpaDMesh2.add(thrSliderAlpha);
      p.add(dpaDMesh2); /* 5 */
      
      Panel dpaDMesh3 = new Panel();
      dpaDMesh3.setLayout(new GridLayout(2,1));
      Label thrlabel23 = new Label("Beta");
      thrlabel23.setFont(new Font("TimesRoman", Font.ITALIC, 10));
      thrSliderBeta = new Scrollbar(Scrollbar.HORIZONTAL,20,20,0, 120);
      thrSliderBeta.setSize(100,50);
      thrSliderBeta.setUnitIncrement (1);
      thrSliderBeta.addAdjustmentListener(this);
      dpaDMesh3.add(thrlabel23);
      dpaDMesh3.add(thrSliderBeta);
      p.add(dpaDMesh3); /* 6 */
      
      Panel dpaDMesh4 = new Panel();
      dpaDMesh4.setLayout(new GridLayout(2,1));
      Label thrlabel24 = new Label("Gamma");
      thrlabel24.setFont(new Font("TimesRoman", Font.ITALIC, 10));
      thrSliderGamma = new Scrollbar(Scrollbar.HORIZONTAL,200,50,0, 250);
      thrSliderGamma.setSize(100,50);
      thrSliderGamma.setUnitIncrement (1);
      thrSliderGamma.addAdjustmentListener(this);
      dpaDMesh4.add(thrlabel24);
      dpaDMesh4.add(thrSliderGamma);
      p.add(dpaDMesh4); /* 7 */
      


      
      Panel dpaMC = new Panel();
      dpaMC.setLayout(new GridLayout(2,1));
      Label thrlabel = new Label("Curvature s-deviation");
      thrlabel.setFont(new Font("TimesRoman", Font.ITALIC, 10));
      thrSlider = new Scrollbar(Scrollbar.HORIZONTAL, 15,2,1, 31);
      thrSlider.setSize(100,50);
      thrSlider.addAdjustmentListener(this);
      dpaMC.add(thrlabel);
      dpaMC.add(thrSlider);
      p.add(dpaMC); /* 8 */
      
      
      Panel dpaPick = new Panel();
      dpaPick.setLayout(new GridLayout(2,1));
      Label pickslidelabel = new Label("Pick-Sphere Radius");
      pickslidelabel.setFont(new Font("TimesRoman", Font.ITALIC, 10));
      pickSlider = new Scrollbar(Scrollbar.HORIZONTAL, 4,2,0, 16);
      pickSlider.setSize(100,50);
      pickSlider.addAdjustmentListener(this);
      dpaPick.add(pickslidelabel);
      dpaPick.add(pickSlider);
      p.add(dpaPick); /* 9 */
            
 
      
	
    }

    /*
     * This creates the Java3D canvas
     */
    private void createCanvasPanel(Panel p) {

        GridBagLayout      gl  = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();

        p.setLayout(gl);
        gbc.gridx = 0;  gbc.gridy = 0;
        gbc.gridwidth = 5;  gbc.gridheight = 5;
        
	
	
	GraphicsConfiguration myconfig = SimpleUniverse.getPreferredConfiguration(); 
        canvas = new Canvas3D(myconfig);
	
	
	canvas.setDoubleBufferEnable(true);
	canvas.setSize(580,480);
        canvas.setBackground(Color.white);
	p.add(canvas,gbc);
	view = new Vector3d(0.0,0.0,0.0);
	mouse  = new Point3d(0.0,0.0,0.0);
	picked = new Point3d(0.0,0.0,0.0);
	Onpicked = new Point3d(0.0,0.0,0.0);
	motion = new Transform3D();
	canvas.addMouseListener(new MouseAdapter() {
	  
	  public void mouseClicked( MouseEvent e ){
	     if(SwingUtilities.isLeftMouseButton(e) && myot!=null){
	       Node node;
	       if(pickstate==1){
		 node = pickSurface(e.getX(),e.getY());
	       
	       if(node != null){
		 
		 
		 universe.getLocale().removeBranchGraph(scene);
		 myot.objTrans.getTransform(motion);
		 motion.invert();
		 motion.transform(picked);
		 
		 int pickID = mypolygon.getNearlestV(picked);
		 pickedCP = mycontrol.AppendCP(mypolygon.numberV,mypolygon.point[pickID].x,
					       mypolygon.point[pickID].y,
					       mypolygon.point[pickID].z,
					       mycontrol.pTail);
		 if(lineot!=null){
		   lineot.unbind();
		   lineot=null;
		 }
		 if(lineot2!=null){
		   lineot2.unbind();
		   lineot2=null;
		 }
		 lineot = new LineTransform(myot.objTrans,new Shape3D(mycontrol.myline),scene,new Color3f(1.0f,0.549020f,0.0f));
		 lineot2 = new LineTransform(myot.objTrans,new Shape3D(mycontrol.myline2),scene,new Color3f(1.0f,0.549020f,0.0f));
		 
		 if(!mytargetp.getState())
		   lineot.unbind();
		 if(!myaniso.getState())
		   lineot2.unbind();
		 
		 System.out.println("pickedCP.ID = "+pickedCP.ID);
		 
		 
		 basesphere.setChild(pickedCP);
		 basesphere2.setChild(pickedCP);
		 picksphere.setChild(pickedCP);
		 
		 setParam(pickedCP);
		 if(pickspherebindstate){
		   
		   if(mytargetp.getState()){
		     basesphere.bind();
		   }
		   if(myaniso.getState()){
		     basesphere2.bind();
		   }
		   picksphere.bind();
		   pickspherebindstate = false;
		 }
		 
	       }
	       
		  		 
	       universe.addBranchGraph(scene);
	       }else{
		 
		 //node = pickNodePRIMITIVE(e.getX(),e.getY());
		 node = pickNode(e.getX(),e.getY());
		 
		 if(node != null){
		    pickedCP = ((PickInfo)(node.getUserData())).pickCP;
		    setParam(pickedCP);
		  }
	       }
	     }
	  }
	  
	  
	  public void mousePressed(MouseEvent e){
	    if(SwingUtilities.isLeftMouseButton(e) && myot!=null){
	      Node node;
	      
	      if(pickstate==1){

	      }else{
		mypolygon.myobj.setPickable(false);
		//node = pickNodePRIMITIVE(e.getX(),e.getY());
		node = pickNode(e.getX(),e.getY());
		
		mypolygon.myobj.setPickable(true);
		if(node != null){
		  objectpickstate=true;
		  //System.out.println("pickedCP.type = "+((PickInfo)(node.getUserData())).type);
		   //System.out.println("pickedCP.type = "+((PickInfo)(node.getUserData())).ID);
		  //System.out.println("pickedCP.ID = "+((PickInfo)(node.getUserData())).pickID);
		  pickedCP = ((PickInfo)(node.getUserData())).pickCP;
		  picktype = ((PickInfo)(node.getUserData())).type;
		  setParam(pickedCP);
		  myot.MouseOff();
		  myot.objTrans.getTransform(motion);
		  motion.transform(pickedCP.point,Onpicked);
		}
	      }
	    }
	  }
	  
	  public void mouseReleased(MouseEvent e){
	  	   
	    if(objectpickstate){
	      if(myot!=null)myot.MouseOn();
	    }
	    objectpickstate=false;
	  }
	  public void mouseEntered(MouseEvent e){}
	  public void mouseExited(MouseEvent e){}
	}
				); 
	
	canvas.addMouseMotionListener(new MouseMotionAdapter() {        
	  public void mouseDragged(MouseEvent e){
	    if(myot!=null && objectpickstate && SwingUtilities.isLeftMouseButton(e)){
	      Point3d nearP=null;
	      setPickCoordinates(e.getX(),e.getY());
	      //System.out.println("pickedCP.ID = "+pickedCP.ID);
	      if(picktype==1){
		picksphere.setPosition(pickedCP.ID,mouse);
		mycontrol.changeCPpoint(pickedCP,mouse);
		if(!myaniso.getState()){
		  basesphere2.setPosition(pickedCP.ID,mouse);
		  mycontrol.changeAnisopoint(pickedCP,mouse);
		}
	      }else if(picktype==0){

		nearP = mypolygon.KnotInit[mypolygon.getNearlestVIP(mouse)];
		basesphere.setPosition(pickedCP.ID,nearP);
		
		mycontrol.changeCPIPpoint(pickedCP,nearP);
	      }else{
		if(myaniso.getState()){
		  if(pickedCP.minID==-1)mypolygon.setMinID();
		  if(pickedCP.at){
		    mycontrol.changeAnisopointConst(pickedCP,mouse);
		    basesphere2.setPosition(pickedCP.ID,pickedCP.anisotropy);
		  }else{
		    mycontrol.changeAnisopoint(pickedCP,mouse);
		    basesphere2.setPosition(pickedCP.ID,pickedCP.anisotropy);
		  }
		}
	      }
	    }
	  }
	  public void mouseMoved(MouseEvent e){}
	}
				      );


    }
  private void setPickCoordinates(int dx,int dy){
    canvas.getPixelLocationInImagePlate(dx,dy,mouse);
    canvas.getImagePlateToVworld(motion);
    
    motion.transform(mouse);
    mouse.z = Onpicked.z;
    myot.objTrans.getTransform(motion);
    
    /*
    if(myot.myscale!=null){
       Transform3D mys = new Transform3D(myot.myscale);
      mys.invert();
      mys.transform(mouse);
      
    }
    */
    motion.invert();
    motion.transform(mouse);
    
  }
  
  private Node pickSurface(int mx,int my){
    PickObject pickObject = new PickObject(canvas,scene);
    PickRay pr=(PickRay)pickObject.generatePickRay(mx,my);
    
    SceneGraphPath sgPath = pickObject.pickClosest(mx,my,PickObject.USE_GEOMETRY);
    if(sgPath==null)return null;
    Node node = pickObject.pickNode(sgPath,PickObject.SHAPE3D,1);
    if(node!=null){
      
      double[] dist=new double[1];
       ((Shape3D)node).intersect(sgPath,pr,dist);
      pr.get(picked,view);
      view.scaleAdd(dist[0],picked);
      picked.set(view);
    }
    sgPath = null;
    return node;
  }

  private Node pickNodePRIMITIVE(int mx,int my){
    mypolygon.myobj.setPickable(false);
    
    
    /* If you want to more fast processing, you can move
       mypolygon.myobj.setPickable(false); and
       mypolygon.myobj.setPickable(true); to 
       the pickstate =3 . 
       */
    PickObject pickObject = new PickObject(canvas,scene);
    
    SceneGraphPath sgPath = pickObject.pickClosest(mx,my,PickObject.USE_GEOMETRY);
    
    if(sgPath==null){
      mypolygon.myobj.setPickable(true);
      
      return null;
    }
    Node node = pickObject.pickNode(sgPath,PickObject.PRIMITIVE,1);
    mypolygon.myobj.setPickable(true);
    
    return node;
  }
  private Node pickNode(int mx,int my){
    PickObject pickObject = new PickObject(canvas,scene);
    SceneGraphPath sgPath = pickObject.pickClosest(mx,my,PickObject.USE_GEOMETRY);
    if(sgPath==null)return null;
    Node node = pickObject.pickNode(sgPath,PickObject.LINK,1);
    return node;
  }
    
  public int getIntTF(TextField dtf){
    int dummyd=1;
     try{ 
	dummyd = (Integer.valueOf(dtf.getText().trim())).intValue();
       }catch(java.lang.NumberFormatException e){
	 if(dtf.getText()!=null){
	   Toolkit tkForBeep = getToolkit(); 
	   tkForBeep.beep();
	   System.out.println("Erorr ! This is not a number.");
	   System.out.println("Please input again.");
	 }
       }
       return (dummyd);
  } 
  public double getDoubleTF(TextField dtf){
    double dummyd=1.0;
     try{ 
	dummyd = (Double.valueOf(dtf.getText().trim())).doubleValue();
       }catch(java.lang.NumberFormatException e){
	 if(dtf.getText()!=null){
	   Toolkit tkForBeep = getToolkit(); 
	   tkForBeep.beep();
	   System.out.println("Erorr ! This is not a number.");
	   System.out.println("Please input again.");
	 }
       }
       return (dummyd);
  }
   public void textValueChanged(TextEvent e){
     
     int dv4 = getIntTF(ENetTimes);
    if((dv4>0)){
      
      numenettimes = dv4;
      
    }else{
      Toolkit tkForBeep = getToolkit(); 
      tkForBeep.beep();
      System.out.println("Erorr ! This is not a number.");
      System.out.println("Please input again.");
    }
   }
 
  private void ColorDMesh(){
    if(DMeshnormalcolor.getState()){
      myot.Surface();
      DMeshnonecolor.setState(false);
      DMeshwireframecolor.setState(false);
      DMeshmeanCPastelcolor.setState(false);
      
    }
    
    if(DMeshnonecolor.getState()){
      myot.Point();
      DMeshnormalcolor.setState(false);
      DMeshwireframecolor.setState(false);
      DMeshmeanCPastelcolor.setState(false);
    }
    
    if(DMeshwireframecolor.getState()){
      myot.WireFrame();
      DMeshnonecolor.setState(false);
      DMeshnormalcolor.setState(false);
      DMeshmeanCPastelcolor.setState(false);
    }
    if(DMeshmeanCPastelcolor.getState()){
      myot.Surface();
      DMeshnonecolor.setState(false);
      DMeshnormalcolor.setState(false);
      DMeshwireframecolor.setState(false);
      //mypolygon.threshold = ((double)(value))/10.0;
      
      mypolygon.setColorPrH();
      if(DMeshmeanCPastelcolor.getState()){
	mypolygon.myobj.setColor(false);
      }
    }
    
    
  }
 
  
  
  public void ColorCheckSet(){
    if(mypolygon!=null && myot!=null){
      ColorDMesh();
      
    }
  }
  
  
  public void actionPerformed (ActionEvent event) {
    
    Object source = event.getSource();
    System.out.println(source);
    if(source == quit) {
      
      checkquit check = new checkquit(this);
    
         
  
    }else if(source ==CameraInit){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	viewpoint.setTransform(initialView);
      }
    }else if(source ==CameraTop){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	Transform3D viewt = new Transform3D();
	eye.x = center.x;
	eye.y = center.y;
	eye.z = center.z+3.0;
	
	up.x = 0.0;
	up.y = 1.0;
	up.z = 0.0;
	viewt.lookAt(eye,center,up);
	viewt.invert();
	viewpoint.setTransform(viewt);
	
      }
    }else if(source ==CameraBottom){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	Transform3D viewt = new Transform3D();
	eye.x = center.x;
	eye.y = center.y;
	eye.z = center.z-3.0;
	
	up.x = 0.0;
	up.y = 1.0;
	up.z = 0.0;
	viewt.lookAt(eye,center,up);
	viewt.invert();
	viewpoint.setTransform(viewt);
	
      }
    }else if(source ==CameraFront){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	Transform3D viewt = new Transform3D();
	eye.x = center.x;
	eye.y = center.y+3.0;
	eye.z = center.z;
	
	up.x = 0.0;
	up.y = 0.0;
	up.z = 1.0;
	viewt.lookAt(eye,center,up);
	viewt.invert();
	viewpoint.setTransform(viewt);
	
      }
    }else if(source ==CameraBack){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	Transform3D viewt = new Transform3D();
	eye.x = center.x;
	eye.y = center.y-3.0;
	eye.z = center.z;
	
	up.x = 0.0;
	up.y = 0.0;
	up.z = 1.0;
	viewt.lookAt(eye,center,up);
	viewt.invert();
	viewpoint.setTransform(viewt);	
      }
    }else if(source ==CameraRight){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	Transform3D viewt = new Transform3D();
	eye.x = center.x+3.0;
	eye.y = center.y;
	eye.z = center.z;
	
	up.x = 0.0;
	up.y = 0.0;
	up.z = 1.0;
	viewt.lookAt(eye,center,up);
	viewt.invert();
	viewpoint.setTransform(viewt);
      }
    }else if(source ==CameraLeft){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	Transform3D viewt = new Transform3D();
	eye.x = center.x-3.0;
	eye.y = center.y;
	eye.z = center.z;
	
	up.x = 0.0;
	up.y = 0.0;
	up.z = 1.0;
	viewt.lookAt(eye,center,up);
	viewt.invert();
	viewpoint.setTransform(viewt);
      }
    }else if (source == Animation) {
      
      if(mypolygon!=null){
      try {
	    
	    if (animate) {
	      this.startloop();
	      Animation.setLabel("Start Animation");
	      Animation.setForeground(teal);
	    }else{
	      this.startloop();
	      Animation.setLabel("Stop Animation");
	      Animation.setForeground(Color.red); 
	    }
	  } catch (Exception e) {
	    System.err.println ("Exception " + e);
	  }
      }
      
    }else if(source ==InitPosition){
      if(myot!=null){
	mypolygon.InitPosition();
      }
        
    
    }else if(source ==ApplyENet){
     if(myot!=null&&mycontrol!=null){
	mypolygon.UpdateCoordinate(numenettimes);
     }
    }else if(source ==pickclear){
     if(myot!=null&&mycontrol!=null){
       picksphere.unbind();
       basesphere.unbind();
       basesphere2.unbind();
       pickedCP=null;
       pickspherebindstate=true;
       mycontrol.initlist();
       basesphere = new PickObjectTransform(Sphereradius,myot.objTrans,myot.getRoot(),0);
       basesphere.unbind();
       basesphere2 = new PickObjectTransform(Sphereradius,myot.objTrans,myot.getRoot(),2);
       basesphere2.unbind();
       
       picksphere = new PickObjectTransform(Sphereradius,myot.objTrans,myot.getRoot(),1);
       picksphere.unbind();
       lineot.unbind();
       lineot=null;
        lineot2.unbind();
       lineot2=null;
     }
    }else  if(source ==savei){
      
      FileDialog saveFileDialog;
      String destinationFileName;
      saveFileDialog = new FileDialog(this,"Save File",FileDialog.SAVE);
      saveFileDialog.setFont(new Font("TimesRoman", Font.BOLD, 18));
      saveFileDialog.pack();
      saveFileDialog.show();
      System.out.println("Please wait...");
      
      Image dummyimage;
      
      
      if (saveFileDialog.getFile() != null){
	destinationFileName = saveFileDialog.getDirectory() +
	  saveFileDialog.getFile();
	JPEGCanvas3D myencode = new JPEGCanvas3D(canvas,destinationFileName);
      }
      
      System.out.println("Save finish !");
    }else  if(source == savep){	   
      
      if(mypolygon!=null && myot!=null){
	FileDialog saveFileDialog;
	String destinationFileName;
	saveFileDialog = new FileDialog(this,"Save File",FileDialog.SAVE);
	saveFileDialog.setFont(new Font("TimesRoman", Font.BOLD, 18));
	saveFileDialog.pack();
	saveFileDialog.show();
	int i,j;
	double dummyvalue=0.0;
	if(saveFileDialog.getFile() != null){
	  destinationFileName = saveFileDialog.getDirectory() +
	    saveFileDialog.getFile();
	  try{
	    
	    FileOutputStream output = 
	      new FileOutputStream(destinationFileName);
	    PrintWriter pwp = new PrintWriter(output);
	    pwp.println(mypolygon.numberV);
	    pwp.println(mypolygon.numberF);
		for(i=0;i<mypolygon.numberV;i++){
		  dummyvalue = ((((mypolygon.point[i]).x)/(mypolygon.scaler)));
		  
		  pwp.println(dummyvalue);
		  dummyvalue = ((((mypolygon.point[i]).y)/(mypolygon.scaler)));
		  pwp.println(dummyvalue);
		  dummyvalue = ((((mypolygon.point[i]).z)/(mypolygon.scaler)));
		  pwp.println(dummyvalue);
		  
		}
		j = 3;
		for(i=0;i<mypolygon.numberF;i++){
		  pwp.println(j);
		  pwp.println((mypolygon.Face[i][0]));
		  pwp.println((mypolygon.Face[i][1]));
		  pwp.println((mypolygon.Face[i][2]));
		}
		System.out.println("Finish Save.");	
		pwp.close();
		output.close();
	  }catch (IOException e){
	    System.out.println("IOException");
	  }
	}
      }
      
    
    }else  if(source == loadp) {
      //if(mycloudp!=null){
      pick1.setState(true);
      pick2.setState(false);
      pickstate=0;
      
      if(picksphere!=null){
	basesphere.unbind();
	pickedCP=null;
	basesphere=null;
	basesphere2.unbind();
	
	basesphere2=null;
	
	picksphere.unbind();
	pickspherebindstate=true;
	picksphere=null;
	if(mycontrol!=null){
	  if(mycontrol.numberV!=0){
	    mycontrol.lineclear();
	  }
	}
	if(lineot!=null){
	  
	  lineot.unbind();
	  lineot=null;
	}
	if(lineot2!=null){
	  lineot2.unbind();
	  lineot2=null;
	}
      }
      if(mypolygon!=null)
	myot.unbind();
      
      DMeshexist.setState(true);
      DMeshbackfaceon.setState(true);
      DMeshmlighton.setState(true);
      DMeshtrOnOff.setState(false);     
      DMeshnormalcolor.setState(true);
      DMeshwireframecolor.setState(false);
      DMeshnonecolor.setState(false);
      DMeshmeanCPastelcolor.setState(false);
      blend.setState(false);
	  
	  FileDialog loadFileDialog;
	  String destinationFileName;
	  loadFileDialog = new FileDialog(this,"Load File",FileDialog.LOAD);
	  loadFileDialog.setFont(new Font("TimesRoman", Font.BOLD, 18));
	  loadFileDialog.pack();
	  loadFileDialog.show();
	  
	  if (loadFileDialog.getFile() != null){
	    destinationFileName = loadFileDialog.getDirectory() +
	      loadFileDialog.getFile();

	    
	    mypolygon = new Polyhedron();
	    
	    if(mypolygon.ReadTPolyData(destinationFileName)){
	      
	      myot = new ObjectTransformEMesh(mypolygon.myobj,scene);
	      mycontrol = new ControlInterface();
	      mypolygon.MakeCP(mycontrol);
	      basesphere = new PickObjectTransform(Sphereradius,myot.objTrans,myot.getRoot(),0);
	      basesphere.unbind();
	      basesphere2 = new PickObjectTransform(Sphereradius,myot.objTrans,myot.getRoot(),2);
	      basesphere2.unbind();
	      picksphere = new PickObjectTransform(Sphereradius,myot.objTrans,myot.getRoot(),1);
	      picksphere.unbind();
	    }else{
	      mypolygon = null;
	      mycontrol=null;
	      System.gc();
	      
	    }
	  }
	
    }else if(source == loadc){
      
      pick1.setState(true);
      pick2.setState(false);
      pickstate=0;
      
      if(picksphere!=null){
	basesphere.unbind();
	pickedCP=null;
	basesphere=null;
	basesphere2.unbind();
	
	basesphere2=null;
	
	picksphere.unbind();
	pickspherebindstate=true;
	picksphere=null;
	if(mycontrol!=null){
	  if(mycontrol.numberV!=0){
	    mycontrol.lineclear();
	  }
	}
	if(lineot!=null){
	lineot.unbind();
	lineot=null;
	}
	if(lineot2!=null){
	lineot2.unbind();
	lineot2=null;
	}
      }
      
      FileDialog loadFileDialog;
      String destinationFileName;
      loadFileDialog = new FileDialog(this,"Load File",FileDialog.LOAD);
      loadFileDialog.setFont(new Font("TimesRoman", Font.BOLD, 18));
      loadFileDialog.pack();
      loadFileDialog.show();
      
      if (loadFileDialog.getFile() != null){
	destinationFileName = loadFileDialog.getDirectory() +
	  loadFileDialog.getFile();
	
	/* this this this */
	mypolygon = new Polyhedron();
	
	if(mypolygon.ReadTPolyData(destinationFileName)){
	  
	  myot = new ObjectTransformEMesh(mypolygon.myobj,scene);
	  mycontrol = new ControlInterface();
	  mypolygon.MakeCP(mycontrol);
	  basesphere = new PickObjectTransform(Sphereradius,myot.objTrans,myot.getRoot(),0);
	  basesphere.unbind();
	  basesphere2 = new PickObjectTransform(Sphereradius,myot.objTrans,myot.getRoot(),2);
	  basesphere2.unbind();
	  picksphere = new PickObjectTransform(Sphereradius,myot.objTrans,myot.getRoot(),1);
	  picksphere.unbind();
	}else{
	  mypolygon = null;
	  mycontrol=null;
	  System.gc();
	  
	}
      }
    
    }
    }
  public IDList next(IDList now)
    {
      return (now.next);
    }
  public IDList back(IDList now)
    {
      return (now.back);
    }
  public void itemStateChanged (ItemEvent event) {
    Object source = event.getSource();
    if(source == pick1){
      pickstate=0;
      
    }else if(source == pick2){
      pickstate=1;
    
    }else if(source == weightFS){
      if(pickedCP!=null){
	pickedCP.w=weightFS.getState();
      }
    }else if(source == cps1){
      if(pickedCP!=null){
	pickedCP.cpstate=0;
      }
    }else if(source == cps2){
      if(pickedCP!=null){
	pickedCP.cpstate=1;
      }
    }else if(source == cps3){
      if(pickedCP!=null){
	pickedCP.cpstate=2;
      }
    }else if(source == cps4){
      if(pickedCP!=null){
	pickedCP.cpstate=3;
      }
    }else if(source==aniaonst){
      if(pickedCP!=null){
	pickedCP.at=aniaonst.getState();
      }
    }else if(source==mytargetp){
      if(mypolygon!=null){
	if(basesphere!=null&&lineot!=null){
	  if(mytargetp.getState()){
	    basesphere.bind();
	    lineot.bind();
	  }else{
	    basesphere.unbind();
	    lineot.unbind();
	  }
	}
      
      }
    }else if(source==myaniso){
      if(mypolygon!=null){
	if(basesphere2!=null&&lineot2!=null){
	  if(myaniso.getState()){
	    basesphere2.bind();
	    lineot2.bind();
	  }else{
	    basesphere2.unbind();
	    lineot2.unbind();
	  }
	}
      
      }
    }else if(source==blend){
      if(mypolygon!=null){
	mypolygon.blend = blend.getState();
      }
    
    }else if(source == DMeshnormalcolor||
	     source == DMeshwireframecolor||
	     source == DMeshnonecolor||
	     source == DMeshbackfaceon||
	     source == DMeshmeanCPastelcolor||
	     source == DMeshmlighton ||
	     source == DMeshtrOnOff||
	     source == DMeshexist
       ){
      if(source==DMeshexist){
	if(mypolygon!=null){
	  if(DMeshexist.getState()){
	    myot.bind();
	  }else{
	    myot.unbind();
	  }
	}else{
	  DMeshexist.setState(false); 
	}
      }else if(source==DMeshtrOnOff){
	if(myot!=null)
	  if(DMeshtrOnOff.getState()){
	    myot.SetTransparency(0.5f);
	  }else{
	    myot.UnsetTransparency();
	  }
      }else if(source==DMeshbackfaceon){
	if(myot!=null)myot.changeBackFace(DMeshbackfaceon.getState());
	
      }else if(source == DMeshmlighton){
	if(myot!=null)myot.changeMLight(DMeshmlighton.getState());
	
      }else{
	if(source== DMeshnormalcolor){
	  if(DMeshnormalcolor.getState()){
	    if(mypolygon!=null){
	      mypolygon.myobj.setColor(true);
	      myot.Surface();
	      
	    }
	    DMeshnonecolor.setState(false);
	    DMeshwireframecolor.setState(false);
	    DMeshmeanCPastelcolor.setState(false);
	  }
	}else if(source== DMeshmeanCPastelcolor){
	  if(DMeshmeanCPastelcolor.getState()){
	    if(mypolygon!=null){
	      mypolygon.myobj.setColor(false);
	      myot.Surface();
	      
	    }
	    DMeshnonecolor.setState(false);
	    DMeshwireframecolor.setState(false);
	    DMeshnormalcolor.setState(false);
	  }
	}else if(source== DMeshnonecolor){
	  if(DMeshnonecolor.getState()){
	    if(mypolygon!=null){
	      myot.Point();
	      
	    }
	    DMeshnormalcolor.setState(false);
	    DMeshwireframecolor.setState(false);
	    DMeshmeanCPastelcolor.setState(false);
	  }
	  
	}else if(source== DMeshwireframecolor){
	  if(DMeshwireframecolor.getState()){
	    if(mypolygon!=null){
	      myot.WireFrame();
	     
	    }
	    DMeshnonecolor.setState(false);
	    DMeshnormalcolor.setState(false);
	    DMeshmeanCPastelcolor.setState(false);
	  }
	}
	
      }
    
    }else if(source == DMeshlighton){
      
      universe.getLocale().removeBranchGraph(scene);
      
      if(!DMeshlighton.getState()){
	mylight.unbind();
	mylight=null;
	
      }else{
	mylight = new LightObject(scene);
      }
      
      universe.addBranchGraph(scene);
    
    
      
    }else if(source == ths1||source == ths2||source == ths3||source == ths4||source == ths5){
      if(!(ths1.getState()||ths2.getState()||
	   ths3.getState()||ths4.getState()||ths5.getState())){
	if(source == ths1){
	  ths1.setState(true);
	}else if (source == ths2){ths2.setState(true);
	}else if (source == ths3){ths3.setState(true);
	}else if (source == ths4){ths4.setState(true);
	}else if (source == ths5){ths5.setState(true);
	}
      }else{
	if(source == ths1){
	  ths2.setState(false);
	  ths3.setState(false);
	  ths4.setState(false);
	  ths5.setState(false);
	  interval = 20;
	}else if (source == ths2){
	  ths1.setState(false);
	  ths3.setState(false);
	  ths4.setState(false);
	  ths5.setState(false);
	  interval = 100;
	}else if (source == ths3){
	  ths2.setState(false);
	  ths1.setState(false);
	  ths4.setState(false);
	  ths5.setState(false);
	  interval = 300;
	}else if (source == ths4){
	  ths2.setState(false);
	  ths3.setState(false);
	  ths1.setState(false);
	  ths5.setState(false);
	  interval = 500;
	}else if (source == ths5){
	  ths2.setState(false);
	  ths3.setState(false);
	  ths4.setState(false);
	  ths1.setState(false);
	  interval = 1000;
	}
      }
    }
  }
  
  

  /* 
   * Adjust the speed of the animations 
   */

  public void setParam(ControlPoint dCP){
  
     thrSliderEpsilon.setValue(((int)(100.0*dCP.epsilon)));
     thrSliderAlpha.setValue(((int)(10.0*dCP.alpha)));
     thrSliderGamma.setValue(((int)(100.0*dCP.gamma))+100);
     if(dCP.cpstate==0){
       cpstateG.setSelectedCheckbox(cps1);
     }else if(dCP.cpstate==1){cpstateG.setSelectedCheckbox(cps2);
     }else if(dCP.cpstate==2){cpstateG.setSelectedCheckbox(cps3);
     }else if(dCP.cpstate==3){cpstateG.setSelectedCheckbox(cps4);
     }
     weightFS.setState(dCP.w);
     aniaonst.setState(dCP.at);
  }

  public void adjustmentValueChanged (AdjustmentEvent e) {
    int value = e.getValue();
    //System.out.println("value = "+value);
    Object source = e.getSource();
    
    if(source==thrSlider){
      if(mypolygon!=null){
	mypolygon.threshold = ((double)(value))/10.0;
	mypolygon.setColorPrH();
	if(DMeshmeanCPastelcolor.getState()){
	  mypolygon.myobj.setColor(false);
	}
      }
    }else if(source==pickSlider){
      Sphereradius = ((float)(((double)(0.01*((double)(value))))));
      if(myot!=null&&picksphere!=null){
	universe.getLocale().removeBranchGraph(scene);
	picksphere.changeSR(Sphereradius);
	basesphere.changeSR(Sphereradius);
	basesphere2.changeSR(Sphereradius);
	
	universe.addBranchGraph(scene);
      }
    }else if(source==thrSliderEpsilon){
       if(mypolygon!=null){
	 if(!Cprop.getState()){
	 if(pickedCP!=null){
	   pickedCP.epsilon = ((double)(0.01*((double)(value))));
	   System.out.println("E["+pickedCP.ID+"] = "+pickedCP.epsilon);
	 }
	 }else{
	   mycontrol.setEAll(((double)(0.01*((double)(value)))));
	   System.out.println("E[all] = "+((double)(0.01*((double)(value)))));
	 }
       }
    }else if(source==thrSliderAlpha){
       if(mypolygon!=null){
	 if(!Cprop.getState()){
	   if(pickedCP!=null){
	     pickedCP.alpha = ((double)(0.1*((double)(value))));
	     System.out.println("alpha["+pickedCP.ID+"] = "+pickedCP.alpha);
	   }
	 }else{
	   mycontrol.setAAll((((double)(0.1*((double)(value))))));
	   System.out.println("alpha[all] = "+(((double)(0.1*((double)(value))))));
	   
	 }
       }
    }else if(source==thrSliderBeta){
      if(mypolygon!=null){
	
	mypolygon.beta = ((double)(0.1*((double)(value))));
	System.out.println("beta = "+mypolygon.beta);
      }
    }else if(source==thrSliderGamma){
       if(mypolygon!=null){
	 if(!Cprop.getState()){
	 if(pickedCP!=null){
	   pickedCP.gamma = ((double)(0.01*((double)(value))))-1.0;
	   System.out.println("E["+pickedCP.ID+"] = "+pickedCP.gamma);
	 }
	 }else{
	   mycontrol.setGAll((((double)(0.01*((double)(value))))-1.0));
	   System.out.println("gamma[all] = "+(((double)(0.01*((double)(value))))-1.0));
	 }
       }
    }
  }

  
  public MenuBar makeIOMenuBar(){
    MenuBar returnout;
    returnout = new MenuBar();
    
    /* file Menu */
    quit = new MenuItem("exit program");
    file = new Menu("file");
    file.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    save = new Menu("save");
    load = new Menu("load");
    save.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    load.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    
    savei = new MenuItem("save image (.jpg)");
    savei.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    savei.addActionListener(this);
   
    quit.addActionListener(this);
   
    loadp = new MenuItem("load (poly2)");
    loadp.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    
    savep = new MenuItem("save (poly2)");
    savep.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    loadp.addActionListener(this);
    savep.addActionListener(this);
    
    load.add(loadp);
    load.addSeparator();
    
    
    save.add(savep);
    save.addSeparator();
    save.add(savei);
    
    file.add(quit);
    
    file.add(load);
    file.add(save);
    returnout.add(file);
    
    /* Menu for DMesh Mesh */
   
    DMeshMeshM = new Menu("Deformation Mesh");
    DMeshMeshM.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    MenuItem DMeshlabel = new MenuItem("E-Mesh");
    DMeshlabel.setFont(new Font("TimesRoman", Font.ITALIC, 13));
    DMeshexist = makeCheckboxMenuItem("exist",false);
    MenuItem DMeshrender = new MenuItem("Rendering Option");
    DMeshrender.setFont(new Font("TimesRoman", Font.ITALIC, 13));
    DMeshnormalcolor = makeCheckboxMenuItem("Normal color",true);
    DMeshmeanCPastelcolor = makeCheckboxMenuItem("M-curvature-Pastel",false);
    DMeshwireframecolor = makeCheckboxMenuItem("WireFrame",false);
    DMeshnonecolor = makeCheckboxMenuItem("Points",false);
    
    DMeshlighton  = makeCheckboxMenuItem("2 Lights",true); 
    DMeshbackfaceon  = makeCheckboxMenuItem("Back Face",true); 
    DMeshmlighton   = makeCheckboxMenuItem("Material Light",true); 
    DMeshtrOnOff  = makeCheckboxMenuItem("transparency",false); 
    DMeshMeshM.addSeparator();
    DMeshMeshM.add(DMeshlabel);
    //DMeshMeshM.add(DMeshexist);
    
    DMeshMeshM.addSeparator();
    DMeshMeshM.addSeparator();
    DMeshMeshM.add(DMeshrender);
    DMeshMeshM.addSeparator();
    DMeshMeshM.add(DMeshnormalcolor);
    DMeshMeshM.add(DMeshmeanCPastelcolor);
    DMeshMeshM.add(DMeshwireframecolor);
    DMeshMeshM.add(DMeshnonecolor);
    DMeshMeshM.addSeparator();
    DMeshMeshM.add(DMeshlighton);
    DMeshMeshM.add(DMeshbackfaceon);
    DMeshMeshM.add(DMeshmlighton);
    DMeshMeshM.add(DMeshtrOnOff);
    DMeshMeshM.addSeparator();
    returnout.add(DMeshMeshM);
    
     
    
    

    MethodConditionM = new Menu("Edit");
    MethodConditionM.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    
    MenuItem MethodConditionMM = new MenuItem("Method Options");
    MethodConditionMM.setFont(new Font("TimesRoman", Font.ITALIC, 13));
    
    

    MenuItem DistOption = new MenuItem("   Dist Option: ");
    DistOption.setFont(new Font("TimesRoman", Font.ITALIC, 13));
    
    blend  = makeCheckboxMenuItem("blending",false); 
    mytargetp= makeCheckboxMenuItem("Ref. Vis.",false);
    myaniso = makeCheckboxMenuItem("Ani. Vis.",false);
    aniaonst  = makeCheckboxMenuItem("Ani. Constrained",true);
    Cprop = makeCheckboxMenuItem("par. change all",false);  
    
    

    MethodConditionM.addSeparator();
    
    MethodConditionM.add(MethodConditionMM);
    MethodConditionM.addSeparator();
    MethodConditionM.addSeparator();
    
   MethodConditionM.add(mytargetp);
   MethodConditionM.add(myaniso);
    MethodConditionM.addSeparator();
   MethodConditionM.add(aniaonst);
   MethodConditionM.addSeparator();
   MethodConditionM.addSeparator();
   MethodConditionM.add(DistOption);
   MethodConditionM.addSeparator();
   MethodConditionM.add(Cprop);
   MethodConditionM.add(blend);
   MethodConditionM.addSeparator();
   

   returnout.add(MethodConditionM);
    
   

    ViewO = new Menu("Camera");
    ViewO.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    MethodConditionM.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    
    MenuItem DMeshViewM = new MenuItem("Camera View Options");
    DMeshViewM.setFont(new Font("TimesRoman", Font.ITALIC, 13));
        
    CameraTop = makeMenuItem("Top");
    CameraInit = makeMenuItem("Init");
    CameraBottom = makeMenuItem("Bottom");
    CameraFront = makeMenuItem("Front");
    CameraBack = makeMenuItem("Back");
    CameraRight = makeMenuItem("Right");
    CameraLeft = makeMenuItem("Left");
    ViewO.addSeparator();
    ViewO.add(DMeshViewM);
     ViewO.addSeparator();
     ViewO.addSeparator();
     ViewO.add(CameraInit);
     ViewO.addSeparator();
     ViewO.add(CameraTop);
     ViewO.add(CameraBottom);
     ViewO.add(CameraFront);
     ViewO.add(CameraBack);
     ViewO.add(CameraRight);
     ViewO.add(CameraLeft);
 
     ViewO.addSeparator();
  returnout.add(ViewO);



  thspeed = new Menu("Th. Speed");
  thspeed.setFont(new Font("TimesRoman", Font.PLAIN, 18));
   
    
  MenuItem DMeshThs = new MenuItem("Thread Speed Options");
  DMeshThs.setFont(new Font("TimesRoman", Font.ITALIC, 13));
  ths1 = makeCheckboxMenuItem("20",true);
  ths2 = makeCheckboxMenuItem("100",false);
  ths3 = makeCheckboxMenuItem("300",false);
  ths4 = makeCheckboxMenuItem("500",false);
  ths5 = makeCheckboxMenuItem("1000",false);
  thspeed.addSeparator();
  thspeed.add(DMeshThs);
  thspeed.addSeparator();
  thspeed.addSeparator();
  thspeed.add(ths1);
  thspeed.add(ths2);
  thspeed.add(ths3);
  thspeed.add(ths4);
  thspeed.add(ths5);
  
  thspeed.addSeparator();
  returnout.add(thspeed);

  return returnout;
    
  }

    public static void main(String[] args) {
     DeformationMesh cardboard = new DeformationMesh();
      cardboard.setSize(800,590);
      cardboard.setTitle("3D Deformation Mesh Simulator");
      cardboard.setVisible(true);
      System.out.println("3D Mesh Deformation Simulator written by Shin Yoshizawa");
      System.out.println("Copyright: Shin Yoshizawa, 2002");
      System.out.println("shin.yoshizawa@mpi-sb.mpg.de");
      System.out.println("Max-Planck-Institut fuer Informatik: AG4");
            
    }
  
}
