/*
3D Mesh Editer via "A Simple Approach to Interactive Free-Form 
Shape Deformations" 
Copyright:(c) Shin Yoshizawa, 2002
E-mail: shin.yoshizawa@mpi-sb.mpg.de
URL: http://www.mpi-sb.mpg.de/~shin
Affiliation: Max-Planck-Institut fuer Informatik: Computer Graphics Group 
 Stuhlsatzenhausweg 85, 66123 Saarbruecken, Germany
 Phone +49 681 9325-414 Fax +49 681 9325-499 

 All right is reserved by Shin Yoshizawa.
This java program and sources are allowed for only primary user of 
research and educational purposes. Don't use secondary: copy, distribution, 
diversion, business purpose, and etc.. 

 */
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.loaders.Scene;
import com.sun.j3d.loaders.objectfile.ObjectFile;
import com.sun.j3d.loaders.ParsingErrorException;
import com.sun.j3d.loaders.IncorrectFormatException;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.behaviors.interpolators.*;
    public class LineTransform {
      public TransformGroup objTrans;
      public TransformGroup ddobjTrans;
      private Group root;
      private BranchGroup bg;
      Appearance app;
      Material m;
      
      LineAttributes pa;
      Color3f eColor = new Color3f(0.0f, 0.0f, 0.0f);
      Color3f sColor = new Color3f(1.0f, 1.0f, 1.0f);
      Color3f normalc = new Color3f(0.2000f,0.6300f,0.7900f);
      
     
   public LineTransform(TransformGroup dobjTrans,Shape3D shape, Group group,Color3f dnormalc){
	ddobjTrans = dobjTrans;
	root = group;
	Transform3D t1 = new Transform3D();
     normalc = new Color3f(dnormalc.x,dnormalc.y,dnormalc.z);

        objTrans = new TransformGroup();
	
        objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	/*
	dobjTrans.getTransform(t1);
	objTrans.setTransform(t1);
	*/
	
	app = new Appearance();
	app.setCapability(app.ALLOW_POLYGON_ATTRIBUTES_WRITE);
	app.setCapability(app.ALLOW_MATERIAL_WRITE);

	pa = new LineAttributes();
	app.setLineAttributes(pa);
	pa.setLineWidth(2.5f);
	m = new Material(normalc, eColor, normalc, sColor, 100.0f);
	m.setCapability(m.ALLOW_COMPONENT_WRITE);
	m.setLightingEnable(true);
	app.setMaterial(m);
	shape.setAppearance(app);
	shape.setCapability(shape.ALLOW_APPEARANCE_WRITE);
	shape.setCapability(shape.ALLOW_APPEARANCE_READ);
	
	shape.setCapability(shape.ALLOW_GEOMETRY_WRITE);
	shape.setCapability(shape.ALLOW_GEOMETRY_READ);
	
	objTrans.addChild(shape);
	
	bg = new BranchGroup();
	bg.setCapability(BranchGroup.ALLOW_DETACH);
	bg.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
	bg.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
	bg.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
	bg.addChild(objTrans);
	dobjTrans.addChild(bg);
	
      }
      
      public void unbind() {
        bg.detach();
      }
      public void bind(){
	ddobjTrans.addChild(bg);
      
      }
            
    }
